/**
 * ASM examples: examples showing how ASM can be use
 * Copyright (c) 2000-2007 INRIA, France Teleco
 * All rights reserved
 
 * Redistribution and use in source and binary forms, with or withou
 * modification, are permitted provided that the following condition
 * are met
 * 1. Redistributions of source code must retain the above copyrigh
 *    notice, this list of conditions and the following disclaimer
 * 2. Redistributions in binary form must reproduce the above copyrigh
 *    notice, this list of conditions and the following disclaimer in th
 *    documentation and/or other materials provided with the distribution
 * 3. Neither the name of the copyright holders nor the names of it
 *    contributors may be used to endorse or promote products derived fro
 *    this software without specific prior written permission
 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, TH
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOS
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS B
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, O
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT O
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINES
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER I
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED O
 * THE POSSIBILITY OF SUCH DAMAGE
 *
import java.io.FileOutputStream
import java.io.FileReader
import java.io.IOException
import java.io.PrintWriter

import org.objectweb.asm.ClassWriter
import org.objectweb.asm.jbfc.BFCompiler
import org.objectweb.asm.util.TraceClassVisitor

/*
 * A naive implementation of compiler for Brain**** language
 * http://www.muppetlabs.com/~breadbox/bf/ 
 *
 * @author Eugene Kulesho
 *
public class jbfc 

    public static void main(final String[] args) throws IOException 
        if (args.length < 2) 
            System.out.println("Usage: jbfc [-v] <bf program file> <java class name>")
            return
        

        boolean verbose = false
        String fileName = null
        String className = null
        for (int i = 0; i < args.length; i++) 
            if ("-v".equals(args[i])) 
                verbose = true
            } else 
                fileName = args[i]
                className = args[i + 1]
                break
            
        

        FileReader r = new FileReader(fileName)

        ClassWriter cw = new ClassWriter(ClassWriter.COMPUTE_MAXS)
        BFCompiler c = new BFCompiler()
        if (verbose) 
            c.compile(r, className, fileName, new TraceClassVisitor(cw
                    new PrintWriter(System.out)))
        } else 
            c.compile(r, className, fileName, cw)
        

        r.close()

        FileOutputStream os = new FileOutputStream(className + ".class")
        os.write(cw.toByteArray())
        os.flush()
        os.close()
    


